/***************************************************************************
                          my_keys.c  -  description
                             -------------------
    begin                : Sat Dec 29 2001
    copyright            : (C) MySQL AB 1997-2001
    author               : venu ( venu@mysql.com )
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "mytest3.h"
#include <stdio.h>


/*
Initialize the foreignkey tables (MySQL specific)
*/
static void my_init_mysql_fkey(SQLHDBC hdbc,SQLHSTMT hstmt)
{
    SQLRETURN rc;     

    SQLExecDirect(hstmt,"DROP DATABASE test_odbc_fk",SQL_NTS);
    SQLExecDirect(hstmt,"CREATE DATABASE test_odbc_fk",SQL_NTS);
    SQLExecDirect(hstmt,"use test_odbc_fk",SQL_NTS);



    rc = SQLExecDirect(hstmt,
"CREATE TABLE `stores` (\
  `stor_id` char(4) NOT NULL,\
  `stor_name` varchar(40) default NULL,\
  `stor_address` varchar(40) default NULL,\
  `city` varchar(20) default NULL,\
  `state` char(2) default NULL,\
  `zip` char(5) default NULL,\
  PRIMARY KEY  (`stor_id`)\
) ENGINE=InnoDB DEFAULT CHARSET=latin1;",SQL_NTS);

    rc = SQLExecDirect(hstmt,
"CREATE TABLE `titles` (\
  `title_id` varchar(6) NOT NULL,\
  `title` varchar(80) NOT NULL,\
  `type` char(12) NOT NULL,\
  `pub_id` char(4) default NULL,\
  `price` decimal(19,4) default NULL,\
  `advance` decimal(19,4) default NULL,\
  `royalty` int(11) default NULL,\
  `ytd_sales` int(11) default NULL,\
  `notes` varchar(200) default NULL,\
  `pubdate` datetime NOT NULL,\
  PRIMARY KEY  (`title_id`),\
  KEY `titleind` (`title`)\
) ENGINE=InnoDB DEFAULT CHARSET=latin1;",SQL_NTS);

    rc = SQLExecDirect(hstmt,
"CREATE TABLE `sales` (\
  `stor_id` char(4) NOT NULL,\
  `ord_num` varchar(20) NOT NULL,\
  `ord_date` datetime NOT NULL,\
  `qty` smallint(6) NOT NULL,\
  `payterms` varchar(12) NOT NULL,\
  `title_id` varchar(6) NOT NULL,\
  PRIMARY KEY  (`stor_id`,`ord_num`,`title_id`),\
  KEY `titleidind` (`title_id`),\
  CONSTRAINT `sales_ibfk_3` FOREIGN KEY (`title_id`) REFERENCES `titles`\
(`title_id`),\
  CONSTRAINT `sales_ibfk_2` FOREIGN KEY (`stor_id`) REFERENCES `stores`\
(`stor_id`)\
) ENGINE=InnoDB DEFAULT CHARSET=latin1;",SQL_NTS);



    SQLFreeStmt(hstmt,SQL_CLOSE);
}

/*
Initialize the foreignkey tables (std)
*/
static void my_init_fkey(SQLHDBC hdbc,SQLHSTMT hstmt)
{

	SQLRETURN rc;     

	SQLExecDirect(hstmt,"DROP DATABASE test_odbc_fk",SQL_NTS);
    SQLExecDirect(hstmt,"CREATE DATABASE test_odbc_fk",SQL_NTS);
    SQLExecDirect(hstmt,"use test_odbc_fk",SQL_NTS);

    SQLFreeStmt(hstmt,SQL_CLOSE);
}

void my_foreign_keys(SQLHDBC hdbc,SQLHSTMT hstmt)
{
//#define TAB_LEN SQL_MAX_TABLE_NAME_LEN + 1
//#define COL_LEN SQL_MAX_COLUMN_NAME_LEN + 1

	LPSTR   szTable;              /* Table to display */

	UCHAR szPkTable[255];   /* Primary key table name */
	UCHAR szFkTable[255];   /* Foreign key table name */
	UCHAR szPkCol[255];     /* Primary key column */
	UCHAR szFkCol[255];     /* Foreign key column */

	SQLINTEGER    cbPkTable, cbPkCol, cbFkTable, cbFkCol, cbKeySeq;
	SQLSMALLINT   iKeySeq;

    SQLRETURN   rc=0;
    SQLCHAR   dbc[255];

    server_is_mysql(hdbc) ? my_init_mysql_fkey(hdbc,hstmt) : my_init_fkey(hdbc,hstmt);

    strcpy(dbc, "test_odbc_fk");

	SQLBindCol(hstmt, 3, SQL_C_CHAR, szPkTable, 255, &cbPkTable);
	SQLBindCol(hstmt, 4, SQL_C_CHAR, szPkCol, 255, &cbPkCol);
	SQLBindCol(hstmt, 5, SQL_C_SSHORT, &iKeySeq, 255, &cbKeySeq);
	SQLBindCol(hstmt, 7, SQL_C_CHAR, szFkTable, 255, &cbFkTable);
	SQLBindCol(hstmt, 8, SQL_C_CHAR, szFkCol, 255, &cbFkCol);

    //strcpy(szTable, "titles");

	//All FK referencing PK of table listed in fld6
    rc = SQLForeignKeys(hstmt,
                        dbc, SQL_NTS,
                        NULL, SQL_NTS,
                        "titles", SQL_NTS,
                        dbc, SQL_NTS,
                        NULL, SQL_NTS,
                        NULL, SQL_NTS);

	fprintf( stdout, "All FK referencing PK table titles: ");

	while ((rc == SQL_SUCCESS) || (rc == SQL_SUCCESS_WITH_INFO)) {

		rc = SQLFetch(hstmt);
		if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO)
			fprintf(stdout, "%-s ( %-s ) <-- %-s ( %-s )\n", szPkTable, szPkCol, szFkTable, szFkCol);
	}


	//strcpy(szTable, "sales");
    //All FK of table listed in fld12
    rc = SQLForeignKeys(hstmt,
                        dbc, SQL_NTS,
                        NULL, SQL_NTS,
                        NULL, SQL_NTS,
                        dbc, SQL_NTS,
                        NULL, SQL_NTS,
                        "sales", SQL_NTS);

	fprintf( stdout, "All FK of table sales: ");
	while ((rc == SQL_SUCCESS) || (rc == SQL_SUCCESS_WITH_INFO)) {

		rc = SQLFetch(hstmt);
		if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO)
			fprintf(stdout, "%-s ( %-s )--> %-s ( %-s )\n", szFkTable, szFkCol, szPkTable, szPkCol);

}

    {
        char buff[255];
        sprintf(buff,"use %s",mydb);
        rc = SQLExecDirect(hstmt, "DROP DATABASE test_odbc_fk", SQL_NTS);
        mystmt(hstmt, rc);
        SQLFreeStmt(hstmt, SQL_CLOSE);
        SQLExecDirect(hstmt, buff, SQL_NTS);
        SQLFreeStmt(hstmt, SQL_CLOSE);
    }
}

/**
MAIN ROUTINE...
*/
int main(int argc, char *argv[])
{


    SQLHENV   henv;
    SQLHDBC   hdbc;
    SQLHSTMT  hstmt;
    SQLINTEGER narg;

    printMessageHeader();

    /*
     * if connection string supplied through arguments, overrite
     * the default one..
    */
    for (narg = 1; narg < argc; narg++)
    {
        if ( narg == 1 )
            mydsn = argv[1];
        else if ( narg == 2 )
            myuid = argv[2];
        else if ( narg == 3 )
            mypwd = argv[3];
    }    

    myconnect(&henv,&hdbc,&hstmt); 
    my_foreign_keys(hdbc,hstmt);   
    mydisconnect(&henv,&hdbc,&hstmt);    

    return(0);
}
